# Haskell bindings for [binaryen][binaryen]

![](https://github.com/tweag/haskell-binaryen/workflows/pipeline/badge.svg?branch=master)

[Binaryen][binaryen] is a compiler and toolchain infrastructure library for
WebAssembly, written in C++. This package defines bindings to the [Binaryen C
API][binaryen-api].

## Versioning

Binaryen evolves fast and can introduce C API changes in every release. Before
building the Haskell bindings, please check the Binaryen version and make sure
it's no less than the minimum version listed below.

| Haskell bindings version | Minimum Binaryen version |
|--------------------------|--------------------------|
| 0.0.1.*                  | version_91               |
| 0.0.2.*                  | version_94               |
| 0.0.3.*                  | version_96               |
| 0.0.4.*                  | version_97               |


## How to build

This package relies on the system-provided Binaryen library. As long as that's
available, a simple `stack build` or `cabal build` command should work.

`Nix`-based build is also supported. Install [Stack][stack] and [Nix][nix].
Then,

```shell
$ stack --nix build
```

[binaryen]: https://github.com/WebAssembly/binaryen
[binaryen-api]: https://github.com/WebAssembly/binaryen/blob/master/src/binaryen-c.h
[nix]: https://nixos.org/nix
[stack]: https://docs.haskellstack.org/en/stable/README
